// This program doesn't support Unicode.

// for Win98 or later.
#define _WIN32_WINDOWS 0x0410

#include <windows.h>
#include "runtime.h"
#include "resource.h"
#include "bit.h"
#include "main.h"

UINT DrawFunc = 2;
UINT RollHeight = 8;
UINT RollWidth = 1;
int EmuPlayTempo = 100;
int EmuPlayKeypitch = 0;

// Emulation
HANDLE hEmuDLL;
BYTE* EmuBuf;
// Prototypes
int (*MaSound_EmuInitialize)(DWORD, DWORD, BYTE*);
int (*MaSound_Initialize)(int, BYTE*, int);
int (*MaSound_DeviceControl)(int, int, int, int);
int (*MaSound_Terminate)();
int (*MaSound_Create)(int);
int (*MaSound_Load)(int, BYTE*, DWORD, int, int, int);
int (*MaSound_Control)(int, int, int, int*, int);
int (*MaSound_Open)(int, int, int, int);
int (*MaSound_Standby)(int, int, int);
int (*MaSound_Start)(int, int, int, int);
int (*MaSound_GetEmuInfo)(int);
int (*MaSound_Stop)(int, int, int);
int (*MaSound_Seek)(int, int, int, int, int);
int (*MaSound_Close)(int, int, int);
int (*MaSound_Unload)(int, int, int);
int (*MaSound_Delete)(int);
int (*MaSound_Terminate)();
int (*MaSound_EmuTerminate)();
int (*SetMidiMsg)(BYTE*, DWORD);
// And functions
BOOL InitEmuFunctions(HANDLE hdll)
{
	if(!((FARPROC)MaSound_EmuInitialize	= GetProcAddress(hdll, "MaSound_EmuInitialize")))	return TRUE;
	if(!((FARPROC)MaSound_Initialize	= GetProcAddress(hdll, "MaSound_Initialize")))		return TRUE;
	if(!((FARPROC)MaSound_DeviceControl	= GetProcAddress(hdll, "MaSound_DeviceControl")))	return TRUE;
	if(!((FARPROC)MaSound_Terminate		= GetProcAddress(hdll, "MaSound_Terminate")))		return TRUE;
	if(!((FARPROC)MaSound_Create		= GetProcAddress(hdll, "MaSound_Create")))			return TRUE;
	if(!((FARPROC)MaSound_Load			= GetProcAddress(hdll, "MaSound_Load")))			return TRUE;
	if(!((FARPROC)MaSound_Control		= GetProcAddress(hdll, "MaSound_Control")))			return TRUE;
	if(!((FARPROC)MaSound_Open			= GetProcAddress(hdll, "MaSound_Open")))			return TRUE;
	if(!((FARPROC)MaSound_Standby		= GetProcAddress(hdll, "MaSound_Standby")))			return TRUE;
	if(!((FARPROC)MaSound_Start			= GetProcAddress(hdll, "MaSound_Start")))			return TRUE;
	if(!((FARPROC)MaSound_GetEmuInfo	= GetProcAddress(hdll, "MaSound_GetEmuInfo")))		return TRUE;
	if(!((FARPROC)MaSound_Stop			= GetProcAddress(hdll, "MaSound_Stop")))			return TRUE;
	if(!((FARPROC)MaSound_Seek			= GetProcAddress(hdll, "MaSound_Seek")))			return TRUE;
	if(!((FARPROC)MaSound_Close			= GetProcAddress(hdll, "MaSound_Close")))			return TRUE;
	if(!((FARPROC)MaSound_Unload		= GetProcAddress(hdll, "MaSound_Unload")))			return TRUE;
	if(!((FARPROC)MaSound_Delete		= GetProcAddress(hdll, "MaSound_Delete")))			return TRUE;
	if(!((FARPROC)MaSound_Terminate		= GetProcAddress(hdll, "MaSound_Terminate")))		return TRUE;
	if(!((FARPROC)MaSound_EmuTerminate	= GetProcAddress(hdll, "MaSound_EmuTerminate")))	return TRUE;
	if(!((FARPROC)SetMidiMsg			= GetProcAddress(hdll, "SetMidiMsg")))				return TRUE;

	return FALSE;
}
// Call EmuInit() once on app starts.
BOOL EmuInit(void)
{
	// WARNING: ̊֐̓[NƂlĂ܂B

	if(!(hEmuDLL = LoadLibrary("M5_EmuSmw5.dll")))
	{
		MessageBox(NULL, "M5_EmuSmw5.dll not found.\nIt requires to run this application.", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}

	InitEmuFunctions(hEmuDLL);

	{
		BYTE* p;

		EmuBuf = halloc(1048576);	// Ƃ肠m
		p = EmuBuf;
		while(((DWORD)p & 0xFF) != 0x81)	// Ȃ񂩂킹Ȃƃ_炵
			p++;

		if(MaSound_EmuInitialize(22050, 2, p))	// p̓AhX1oCg0x81ȏ?łȂĂ͂ȂȂ炵BAlign?
		{
			MessageBox(NULL, "EmuInitialize failed!", "Error", MB_ICONERROR | MB_OK);
			return FALSE;
		}

		if(MaSound_Initialize(0, EmuBuf, 0))	// ͑v?
		{
			MessageBox(NULL, "Initialize failed!", "Error", MB_ICONERROR | MB_OK);
			return FALSE;
		}
		// ꂪPCMȉȂȂ悤ŁB
		if(MaSound_DeviceControl(0x0D, 0, 0, 0))
		{
			MessageBox(NULL, "DeviceControl(0x0D, 0, 0, 0) failed!", "Error", MB_ICONERROR | MB_OK);
			return FALSE;
		}
		if(MaSound_DeviceControl(0x05, 2, 0, 0))
		{
			MessageBox(NULL, "DeviceControl(0x05, 2, 0, 0) failed!", "Error", MB_ICONERROR | MB_OK);
			return FALSE;
		}
		// ŏɎsĂ̂AĂ݂
		if(MaSound_DeviceControl(0x06, 0, 0, 0))
		{
			MessageBox(NULL, "DeviceControl(0x06, 0, 0, 0) failed!", "Error", MB_ICONERROR | MB_OK);
			return FALSE;
		}
		if(MaSound_DeviceControl(0x08, 2, 0, 0))
		{
			MessageBox(NULL, "DeviceControl(0x08, 2, 0, 0) failed!", "Error", MB_ICONERROR | MB_OK);
			return FALSE;
		}
		// ŏɎsĂ̂AĂ݂ 2
		if(MaSound_DeviceControl(0x09, 0, 0, 0))
		{
			MessageBox(NULL, "DeviceControl(0x09, 0, 0, 0) failed!", "Error", MB_ICONERROR | MB_OK);
			return FALSE;
		}
		if(MaSound_Create(1) != 1)
		{
			MessageBox(NULL, "Create failed!", "Error", MB_ICONERROR | MB_OK);
			return FALSE;
		}
		/*
		if(MaSound_DeviceControl(0x05, 2, 0, 0))
		{
			MessageBox(hWnd, "DeviceControl(0x05, 2, 0, 0) 2nd failed!", "Error", MB_ICONERROR | MB_OK);
			return FALSE;
		}
		if(MaSound_DeviceControl(0x06, 0, 0, 0))
		{
			MessageBox(hWnd, "DeviceControl(0x06, 0, 0, 0) 2nd failed!", "Error", MB_ICONERROR | MB_OK);
			return FALSE;
		}
		if(MaSound_DeviceControl(0x08, 2, 0, 0))
		{
			MessageBox(hWnd, "DeviceControl(0x08, 2, 0, 0) 2nd failed!", "Error", MB_ICONERROR | MB_OK);
			return FALSE;
		}
		if(MaSound_DeviceControl(0x09, 0, 0, 0))
		{
			MessageBox(hWnd, "DeviceControl(0x09, 0, 0, 0) 2nd failed!", "Error", MB_ICONERROR | MB_OK);
			return FALSE;
		}
		*/
	}

	return TRUE;
}
// ȍ~Control(1,1,6,0,0)̃Xe[^XmFhĈłȂB
BOOL EmuOpen(SMAF* smaf)
{
	// open
	if(MaSound_Load(1, smaf->data, smaf->size, 1, (int)NULL, 0) != 1)	// ȂATS-MA5݂ƃR[obNۂǁAATS-MA5ł͈xĂ΂ĂȂBNULLw肵ĂOK̂ō̗pB
	{
		MessageBox(NULL, "Load failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}
	if(MaSound_Open(1, 1, 0, 0))
	{
		MessageBox(NULL, "Open failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}
	if(MaSound_Standby(1, 1, 0))
	{
		MessageBox(NULL, "Standby failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}

	return TRUE;
}
BOOL EmuPlay(SMAF* smaf)
{
	DWORD val;

	// Play
	// 
	val = 100;
	if(MaSound_Control(1, 1, 0, &val, 0))
	{
		MessageBox(NULL, "Control volume failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}
	// L[sb` between -12 to 12
	val = EmuPlayKeypitch;
	if(MaSound_Control(1, 1, 2, &val, 0))
	{
		MessageBox(NULL, "Control keypitch failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}
	// e|(%) between 70 to 130.
	val = EmuPlayTempo;
	if(MaSound_Control(1, 1, 1, &val, 0))
	{
		MessageBox(NULL, "Control tempo failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}

	if(MaSound_Start(1, 1, 1, 0))
	{
		MessageBox(NULL, "Start failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}

	return TRUE;
}
void EmuStop(void)
{
	MaSound_Stop(1, 1, 0);

	return;
}
void EmuClose(void)
{
	MaSound_Close(1, 1, 0);
	MaSound_Unload(1, 1, 0);

	return;
}
void EmuTerminate(void)
{
	MaSound_Delete(1);
	MaSound_Terminate();
	MaSound_EmuTerminate();

	FreeLibrary(hEmuDLL);

	hfree(EmuBuf);

	return;
}

//Đ̏
void EmuStatus(HWND hWnd)
{
	switch(MaSound_Control(1, 1, 6, 0, 0))
	{
	case 4:
		break;
	case 3:
		SendMessage(hWnd, WM_COMMAND, ID_STOP, 0);
		return;
	default:
		MessageBox(hWnd, "Status != 4,3", "Error", MB_ICONERROR | MB_OK);
		return;
	}

	{
		TCHAR ts[256];
		DWORD curr = MaSound_Control(1, 1, 4, 0, 0);
		DWORD emuinfo = MaSound_GetEmuInfo(4);

		wsprintf(ts, "mmf tool %06dms ", curr);
		if(emuinfo & 0x01)
			lstrcat(ts, "LED ");
		if(emuinfo & 0x02)
			lstrcat(ts, "Vib ");
		SetWindowText(hWnd, ts);
	}

	return;
}




BOOL CALLBACK MessageDlgWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	if(msg == WM_INITDIALOG)
		return TRUE;
	if(msg == WM_COMMAND && (wParam == IDOK || wParam == IDCANCEL))
		EndDialog(hWnd, wParam);

	return FALSE;
}

BOOL findchunk4(BYTE* data, DWORD dsize, char* cname, CHUNK* ch)
{
	DWORD cur;

	for(cur = 0; cur < dsize; )
	{
		if(!memcomp(data + cur, cname, 4))
		{
			ch->data = data + cur + 8;
			ch->size = SwapDword(data + cur + 4);
			return TRUE;
		}
		cur += 8 + SwapDword(data + cur + 4);
	}

	return FALSE;
}

BOOL findchunk3(BYTE* data, DWORD dsize, char* cname, CHUNK* ch)
{
	DWORD cur;

	for(cur = 0; cur < dsize; )
	{
		if(!memcomp(data + cur, cname, 3))
		{
			ch->data = data + cur + 8;
			ch->size = SwapDword(data + cur + 4);
			return TRUE;
		}
		cur += 8 + SwapDword(data + cur + 4);
	}

	return FALSE;
}

DWORD GetVValAndForward(BYTE** pdata)
{
	DWORD val = 0;

	do
	{
		val <<= 7;
		val |= **pdata & 0x7F;
	}while(*(*pdata)++ & 0x80);

	return val;
}

DWORD GetVVal(BYTE* pdata)
{
	DWORD val = 0;

	do
	{
		val <<= 7;
		val |= *pdata & 0x7F;
	}while(*pdata++ & 0x80);

	return val;
}

void ClearEvents(SMAF* smaf)
{
	EVENT* e = smaf->events;

	while(e)
	{
		EVENT* next = e->next;
		hfree(e->data);
		hfree(e);
		e = next;
	}

	smaf->events = NULL;

	return;
}

// for HPS: convert to MSF
void ConvertEvents2(SMAF* smaf, BYTE* data, DWORD size, BOOL fsetup)
{
	EVENT* ev = smaf->events;
	BYTE* p;
	DWORD tdur = 0;
	signed int octshift = 0;

	// go last event
	if(ev)
	{
		while(ev->next)
			ev = ev->next;
		tdur = ev->time;
	}

	for(p = data; p < data + size; )
	{	// Ignore error ;-(
		// Maybe, there is more nice efficiency routine.
		EVENT* e;
		BYTE esize = 1;	// command size

		e = halloc(sizeof(EVENT));
		if(fsetup)
			e->duration = 0;
		else
			e->duration = GetVValAndForward(&p) * smaf->dbase;
		tdur += e->duration;
		e->time = tdur;
		e->status = 0;
		e->size = 0;
		e->data = NULL;

		// Parse status!!
		if(p[0] == 0xFF && p[1] == 0xF0)	// Exclusive
		{
			esize = 2 + p[2] + 1;
			e->size = p[2] + 1;
			e->status = 0xF0;
			e->data = halloc(e->size);
			memcopy(e->data, p + 2, e->size);
		}else if(p[0] == 0xFF && p[1] == 0x00)	// NOP
		{
			esize = 2;
			e->size = 1;
			e->data = halloc(e->size);
			e->status = 0xFF;
			e->data[0] = 0x00;
		}else
		{
			if(p[0] != 0x00)	// Note
			{
				BYTE ch;
				BYTE oct;
				BYTE note;
				BYTE absnote;

				ch = p[0] >> 6 & 0x03;
				oct = p[0] >> 4 & 0x03;
				note = p[0] & 0x0F;
				// MIDI's 69 = 440Hz(A) = Oct2,9
				absnote = 36 + (oct + octshift) * 12 + note;

				e->status = 0x80 | ch;
				{
					BYTE* q = p + 1;

					GetVValAndForward(&q);
					esize = q - p;
					e->size = q - p;
					e->data = halloc(e->size);

					e->data[0] = absnote;
					if(p[1] & 0x80)
					{
						e->data[1] = p[1];
						e->data[2] = p[2];
					}else
						e->data[1] = p[1];
				}
			}else
			{
				BYTE ch;
				ch = p[1] >> 6 & 0x03;

				if(p[1] == 0x00 && p[2] == 0x00 && p[3] == 0x00)	// EOS?
					esize = 4;
				if((p[1] & 0x30) == 0x30)
				{
					if((p[1] & 0x0F) == 0x00)	// Program Change
					{
						esize = 3;
						e->size = 1;
						e->data = halloc(e->size);
						e->status = 0xC0 | ch;
						e->data[0] = p[2];
					}
					if((p[1] & 0x0F) == 0x01)	// Bank Select
					{
						esize = 3;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x00;	// banksel
						e->data[1] = p[2];
					}
					if((p[1] & 0x0F) == 0x02)	// Octave Shift
					{
						esize = 3;
						octshift = (signed char)p[2];

						// NOP
						e->size = 1;
						e->data = halloc(e->size);
						e->status = 0xFF;
						e->data[0] = 0x00;
					}
					if((p[1] & 0x0F) == 0x03)	// Modulation
					{
						esize = 3;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x01;	// mod.
						e->data[1] = p[2];
					}
					if((p[1] & 0x0F) == 0x04)	// PitchBend
					{
						esize = 3;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xE0 | ch;
						e->data[0] = 0x00;
						e->data[1] = p[2];	// tenuki.
					}
					if((p[1] & 0x0F) == 0x07)	// Volume
					{
						esize = 3;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x07;	// vol
						e->data[1] = p[2];
					}
					if((p[1] & 0x0F) == 0x0A)	// Pan
					{
						esize = 3;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x0A;	// pan
						e->data[1] = p[2];
					}
					if((p[1] & 0x0F) == 0x0B)	// Expression
					{
						esize = 3;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x0B;	// exp.
						e->data[1] = p[2];
					}
				}else
				{
					if((p[1] & 0x30) == 0x00)	// Expression
					{
						esize = 2;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x0B;	// exp.
						e->data[1] = (p[1] & 0xF0) << 3;
					}
					if((p[1] & 0x30) == 0x10)	// PitchBend
					{
						esize = 2;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xE0 | ch;
						e->data[0] = 0x00;
						e->data[1] = (p[1] & 0xF0) << 3;	// chou tenuki
					}
					if((p[1] & 0x30) == 0x20)	// Modulation
					{
						esize = 2;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x01;	// mod.
						e->data[1] = (p[1] & 0xF0) << 3;
					}
				}
			}
		}

		if(esize == 1)
		{
			TCHAR ts[256];

			wsprintf(ts, "What's this? %02X", p[0]);
			MessageBox(NULL, ts, "Error", MB_ICONERROR | MB_OK);
		}

		p += esize;

		e->next = NULL;

		if(!ev)
			smaf->events = e;
		else
			ev->next = e;

		ev = e;
	}

	return;
}

// for MSF
void ConvertEvents(SMAF* smaf, BYTE* data, DWORD size, BOOL fsetup)
{
	EVENT* ev = smaf->events;
	BYTE* p;
	DWORD tdur = 0;

	if(ev)
	{
		while(ev->next)
			ev = ev->next;
		tdur = ev->time;
	}

	for(p = data; p < data + size; )
	{	// Ignore error ;-(
		// Maybe, there is more nice efficiency routine.
		EVENT* e;

		e = halloc(sizeof(EVENT));
		if(fsetup)
			e->duration = 0;
		else
			e->duration = GetVValAndForward(&p) * smaf->dbase;
		tdur += e->duration;
		e->time = tdur;
		e->status = *p++;
		e->size = 0;
		e->data = NULL;

		// Parse status!!
		if((e->status & 0xF0) == 0x80)	// Note w/o verocity
		{
			BYTE* q = p + 1;

			GetVValAndForward(&q);
			e->size = q - p;
		}
		if((e->status & 0xF0) == 0x90)	// Note w/ verocity
		{
			BYTE* q = p + 2;

			GetVValAndForward(&q);
			e->size = q - p;
		}
		if((e->status & 0xF0) == 0xA0)	// Resv 3byte
		{
			e->size = 3;
		}
		if((e->status & 0xF0) == 0xB0)	// Control Change
		{
			e->size = 2;
		}
		if((e->status & 0xF0) == 0xC0)	// Program Change
		{
			e->size = 1;
		}
		if((e->status & 0xF0) == 0xD0)	// Resv 2byte
		{
			e->size = 2;
		}
		if((e->status & 0xF0) == 0xE0)	// PitchBend
		{
			e->size = 2;
		}
		if(e->status == 0xF0)	// Exclusive
		{
			BYTE* q = p;

			e->size = GetVValAndForward(&q);
			e->size += (q - p);	// VVal size
		}
		if(e->status == 0xFF)	// NOP or EOS
		{
			if(*p == 0x00)
				e->size = 1;
			if(*p == 0x2F)
				e->size = 2;
		}

		// copy.
		if(e->size)
		{
			e->data = halloc(e->size);
			memcopy(e->data, p, e->size);
			p += e->size;
		}else
			MessageBox(NULL, "Bug or illegal", "What", MB_OK);

		e->next = NULL;

		if(!ev)
			smaf->events = e;
		else
			ev->next = e;

		ev = e;
	}

#if 0
	// for debugging test
	{
		EVENT* e;

		e = halloc(sizeof(EVENT));
		e->duration = 0;
		tdur += e->duration * dbase;
		e->time = tdur;
		e->status = 0xFF;
		e->size = 1;
		e->data = halloc(e->size);
		e->data[0] = 0x00;
		e->next = NULL;
		ev->next = e;
	}
#endif

	return;
}

void draw(HWND hWnd, HDC hdc, int width, int height, SMAF* smaf, DWORD playingpos)
{
	HFONT hfold;
	int scrx, scry;

	SetTextColor(hdc, RGB(0, 0, 0));
	SetBkMode(hdc, TRANSPARENT);

	if(!smaf)
	{
		FillRectangle(hdc, 0, 0, width, height, GetSysColor(COLOR_3DFACE));
		MoveToEx(hdc, 0, 0, NULL);
		PutText(hdc, "Open please.");

		return;
	}

	FillRectangle(hdc, 0, 0, width, height, RGB(255, 255, 255));

	{
		LOGFONT lf = {0};

		lf.lfCharSet = DEFAULT_CHARSET;
		strcopy(lf.lfFaceName, "lr SVbN");
		lf.lfHeight = -12;

		hfold = SelectObject(hdc, CreateFontIndirect(&lf));
	}

	{
		SCROLLINFO vsi, hsi;

		vsi.cbSize = hsi.cbSize = sizeof(SCROLLINFO);
		vsi.fMask = hsi.fMask = SIF_POS;
		GetScrollInfo(hWnd, SB_VERT, &vsi);
		GetScrollInfo(hWnd, SB_HORZ, &hsi);

		scrx = hsi.nPos;
		scry = vsi.nPos;

		/*
		{
			SIZE s;

			GetTextExtentPoint32(hdc, "A", 1, &s);
			MoveToEx(hdc, hsi.nPos * -s.cx, vsi.nPos * -s.cy, NULL);
		}
		*/
	}

#if 0
	{
		CHUNK mmmd;
		CHUNK dummy;

		if(!findchunk4(smaf->data, smaf->size, "MMMD", &mmmd))
		{
			PutText(hdc, "MMMD NOT FOUND");
			return;
		}

		mmmd.size -= 2;	// CRC

		{
			CHUNK cnti;

			if(!findchunk4(mmmd.data, mmmd.size, "CNTI", &cnti))
			{
				PutText(hdc, "CNTI NOT FOUND");
				return;
			}

			PutText(hdc, "CNTI info");

			if(cnti.data[0] == 0x00)
				PutText(hdc, "Contents class: YAMAHA");
			else
				PutText(hdc, "Contents class: Not yamaha %02X", cnti.data[0]);

			if((0x00 <= cnti.data[1] && cnti.data[1] <= 0x0F) || (0x30 <= cnti.data[1] && cnti.data[1] <= 0x33))
				PutText(hdc, "Contents type: Ringtone %02X", cnti.data[1]);
			else if((0x10 <= cnti.data[1] && cnti.data[1] <= 0x1F) || (0x40 <= cnti.data[1] && cnti.data[1] <= 0x42))
				PutText(hdc, "Contents type: Karaoke %02X", cnti.data[1]);
			else if((0x20 <= cnti.data[1] && cnti.data[1] <= 0x2F) || (0x50 <= cnti.data[1] && cnti.data[1] <= 0x53))
				PutText(hdc, "Contents type: CM %02X", cnti.data[1]);
			else
				PutText(hdc, "Contents type: RESERVED %02X", cnti.data[1]);

			switch(cnti.data[2])
			{
			case 0x00: PutText(hdc, "Contents code: Shift-JIS"); break;
			case 0x01: PutText(hdc, "Contents code: Latin-1"); break;
			case 0x02: PutText(hdc, "Contents code: EUC-KR"); break;
			case 0x03: PutText(hdc, "Contents code: GB-2312"); break;
			case 0x04: PutText(hdc, "Contents code: Big5"); break;
			case 0x05: PutText(hdc, "Contents code: KOI8-R"); break;
			case 0x06: PutText(hdc, "Contents code: TCVN-5773:1993"); break;
			case 0x20: PutText(hdc, "Contents code: UCS-2"); break;
			case 0x21: PutText(hdc, "Contents code: UCS-4"); break;
			case 0x22: PutText(hdc, "Contents code: UTF-7"); break;
			case 0x23: PutText(hdc, "Contents code: UTF-8"); break;
			case 0x24: PutText(hdc, "Contents code: UTF-16"); break;
			case 0x25: PutText(hdc, "Contents code: UTF-32"); break;
			default: PutText(hdc, "Contents code: RESERVED %02X", cnti.data[2]); break;
			}

			if(cnti.data[3] & 0x04)
				PutText(hdc, "CopyStatus: Edit NG");
			else
				PutText(hdc, "CopyStatus: Edit OK");
			if(cnti.data[3] & 0x02)
				PutText(hdc, "CopyStatus: Save NG");
			else
				PutText(hdc, "CopyStatus: Save OK");
			if(cnti.data[3] & 0x01)
				PutText(hdc, "CopyStatus: Trans NG");
			else
				PutText(hdc, "CopyStatus: Trans OK");

			PutText(hdc, "Copy Count: %d", cnti.data[4]);

			if(cnti.size > 5)
			{
				DWORD i, j;

				PutText(hdc, "Optional data followed.");

				for(i = 5; i < cnti.size; )
				{
					char tag[16];
					char data[256];

					tag[0] = cnti.data[i];
					tag[1] = cnti.data[i + 1];
					tag[2] = '\0';

					if(cnti.data[i] == 'V' && cnti.data[i + 1] == 'N')
						lstrcpy(tag, "Vendor");
					if(cnti.data[i] == 'C' && cnti.data[i + 1] == 'N')
						lstrcpy(tag, "Carrior");
					if(cnti.data[i] == 'C' && cnti.data[i + 1] == 'A')
						lstrcpy(tag, "Category");
					if(cnti.data[i] == 'S' && cnti.data[i + 1] == 'T')
						lstrcpy(tag, "Title");
					if(cnti.data[i] == 'A' && cnti.data[i + 1] == 'N')
						lstrcpy(tag, "Artist");
					if(cnti.data[i] == 'W' && cnti.data[i + 1] == 'W')
						lstrcpy(tag, "Word");
					if(cnti.data[i] == 'S' && cnti.data[i + 1] == 'W')
						lstrcpy(tag, "Music");
					if(cnti.data[i] == 'A' && cnti.data[i + 1] == 'W')
						lstrcpy(tag, "Edit");
					if(cnti.data[i] == 'C' && cnti.data[i + 1] == 'R')
						lstrcpy(tag, "Copyright");
					if(cnti.data[i] == 'G' && cnti.data[i + 1] == 'R')
						lstrcpy(tag, "CR-Group");
					if(cnti.data[i] == 'M' && cnti.data[i + 1] == 'I')
						lstrcpy(tag, "ManInfo");
					if(cnti.data[i] == 'C' && cnti.data[i + 1] == 'D')
						lstrcpy(tag, "Create");
					if(cnti.data[i] == 'U' && cnti.data[i + 1] == 'D')
						lstrcpy(tag, "Update");
					if(cnti.data[i] == ' ' && cnti.data[i + 1] == 'C')
						lstrcpy(tag, "Copy by?");
					i += 3;

					for(j = i; /*Fact=IllegalFile->*/j < cnti.size && cnti.data[j] != ','; j++)
						;
					memcopy(data, cnti.data + i, j - i);
					data[j - i] = '\0';

					i = j + 1;

					{
						TCHAR ts[256];
						wsprintf(ts, "%s: %s", tag, data);
						PutText(hdc, ts);
					}
				}
			}
		}

		{
			CHUNK opda;

			if(findchunk4(mmmd.data, mmmd.size, "OPDA", &opda))
			{
				CHUNK dch;
				PutText(hdc, "OPDA found.");

				if(findchunk3(opda.data, opda.size, "Dch", &dch))
				{
					DWORD i;
					PutText(hdc, "Dch found.");

					for(i = 0; i < dch.size; )
					{
						char tag[16];
						char data[256];

						tag[0] = dch.data[i];
						tag[1] = dch.data[i + 1];
						tag[2] = '\0';

						if(dch.data[i] == 'V' && dch.data[i + 1] == 'N')
							lstrcpy(tag, "Vendor");
						if(dch.data[i] == 'C' && dch.data[i + 1] == 'N')
							lstrcpy(tag, "Carrior");
						if(dch.data[i] == 'C' && dch.data[i + 1] == 'A')
							lstrcpy(tag, "Category");
						if(dch.data[i] == 'S' && dch.data[i + 1] == 'T')
							lstrcpy(tag, "Title");
						if(dch.data[i] == 'A' && dch.data[i + 1] == 'N')
							lstrcpy(tag, "Artist");
						if(dch.data[i] == 'W' && dch.data[i + 1] == 'W')
							lstrcpy(tag, "Word");
						if(dch.data[i] == 'S' && dch.data[i + 1] == 'W')
							lstrcpy(tag, "Music");
						if(dch.data[i] == 'A' && dch.data[i + 1] == 'W')
							lstrcpy(tag, "Edit");
						if(dch.data[i] == 'C' && dch.data[i + 1] == 'R')
							lstrcpy(tag, "Copyright");
						if(dch.data[i] == 'G' && dch.data[i + 1] == 'R')
							lstrcpy(tag, "CR-Group");
						if(dch.data[i] == 'M' && dch.data[i + 1] == 'I')
							lstrcpy(tag, "ManInfo");
						if(dch.data[i] == 'C' && dch.data[i + 1] == 'D')
							lstrcpy(tag, "Create");
						if(dch.data[i] == 'U' && dch.data[i + 1] == 'D')
							lstrcpy(tag, "Update");
						if(dch.data[i] == 'E' && dch.data[i + 1] == 'S')
							lstrcpy(tag, "EditState");
						if(dch.data[i] == 'V' && dch.data[i + 1] == 'C')
							lstrcpy(tag, "vCard");
						if(dch.data[i] == ' ' && dch.data[i + 1] == 'C')
							lstrcpy(tag, "Copy by?");
						i += 2;

						memcopy(data, dch.data + i + 2, SwapWord(dch.data + i));
						data[SwapWord(dch.data + i)] = '\0';

						i += SwapWord(dch.data + i) + 2;

						{
							TCHAR ts[256];
							wsprintf(ts, "%s: %s", tag, data);
							PutText(hdc, ts);
						}					
					
					}
				}
			}
		}

		{
			CHUNK mtr;

			if(findchunk3(mmmd.data, mmmd.size, "MTR", &mtr))
			{
				PutText(hdc, "MTR info");

				switch(mtr.data[0])
				{
				case 0x00: PutText(hdc, "Format Type: HandyPhone Standard (MA-1,2)"); break;
				case 0x01: PutText(hdc, "Format Type: Mobile Standard(Compress)"); break;
				case 0x02: PutText(hdc, "Format Type: Mobile Standard(No Compress) (MA-3,5)"); break;
				case 0x03: PutText(hdc, "Format Type: MA-7"); break;
				default: PutText(hdc, "Format Type: RESERVED %02X", mtr.data[0]); break;
				}

				switch(mtr.data[1])
				{
				case 0x00: PutText(hdc, "Sequence Type: Stream sequence"); break;
				case 0x01: PutText(hdc, "Sequence Type: Sub-sequence"); break;
				default: PutText(hdc, "Sequence Type: RESERVED %02X", mtr.data[0]); break;
				}

				switch(mtr.data[2])
				{
				case 0x00: PutText(hdc, "TimeBase(Duration): 1 msec"); break;
				case 0x01: PutText(hdc, "TimeBase(Duration): 2 msec"); break;
				case 0x02: PutText(hdc, "TimeBase(Duration): 4 msec"); break;
				case 0x03: PutText(hdc, "TimeBase(Duration): 5 msec"); break;
				case 0x10: PutText(hdc, "TimeBase(Duration): 10 msec"); break;
				case 0x11: PutText(hdc, "TimeBase(Duration): 20 msec"); break;
				case 0x12: PutText(hdc, "TimeBase(Duration): 40 msec"); break;
				case 0x13: PutText(hdc, "TimeBase(Duration): 50 msec"); break;
				default: PutText(hdc, "Sequence Type: RESERVED %02X", mtr.data[0]); break;
				}

				switch(mtr.data[3])
				{
				case 0x00: PutText(hdc, "TimeBase(GateTime): 1 msec"); break;
				case 0x01: PutText(hdc, "TimeBase(GateTime): 2 msec"); break;
				case 0x02: PutText(hdc, "TimeBase(GateTime): 4 msec"); break;
				case 0x03: PutText(hdc, "TimeBase(GateTime): 5 msec"); break;
				case 0x10: PutText(hdc, "TimeBase(GateTime): 10 msec"); break;
				case 0x11: PutText(hdc, "TimeBase(GateTime): 20 msec"); break;
				case 0x12: PutText(hdc, "TimeBase(GateTime): 40 msec"); break;
				case 0x13: PutText(hdc, "TimeBase(GateTime): 50 msec"); break;
				default: PutText(hdc, "Sequence Type: RESERVED %02X", mtr.data[0]); break;
				}

				if(mtr.data[0] == 0x02)
				{
					PutText(hdc, "Analysing MA-3,5 deep...");

					{
						int i;
						for(i = 0; i < 16; i++)
						{
							TCHAR ts[1024];
							wsprintf(ts, "Channel %i: KCS=", i);
							switch(mtr.data[4 + i] >> 6)
							{
							case 0x00: lstrcat(ts, "None "); break;
							case 0x01: lstrcat(ts, "OFF "); break;
							case 0x02: lstrcat(ts, "ON "); break;
							case 0x03: lstrcat(ts, "RESERVED "); break;
							}
							if(mtr.data[4 + i] & 0x20)
								lstrcat(ts, "Vib ");
							if(mtr.data[4 + i] & 0x10)
								lstrcat(ts, "LED ");
							switch(mtr.data[4 + i] & 0x03)
							{
							case 0x00: lstrcat(ts, "Nocare "); break;
							case 0x01: lstrcat(ts, "Melody "); break;
							case 0x02: lstrcat(ts, "NON Melody "); break;
							case 0x03: lstrcat(ts, "Rhythm "); break;
							}
							PutText(hdc, ts);
						}
					}

					mtr.data += 4 + 16;

					if(findchunk4(mtr.data, mtr.size, "MspI", &dummy))
						PutText(hdc, "MspI Info found.");

					if(findchunk4(mtr.data, mtr.size, "Mtsu", &dummy))
						PutText(hdc, "Mtsu Setup found.");

					if(findchunk4(mtr.data, mtr.size, "Mtsq", &dummy))
						PutText(hdc, "Mtsq Sequence found.");

					if(findchunk4(mtr.data, mtr.size, "Mtsp", &dummy))
						PutText(hdc, "Mtsp PCM found.");
				}
			}
		}
	}

	PutText(hdc, "EventList!");

	{
		EVENT* e = smaf->events;
		DWORD count = 0;

		PutText(hdc, "<Line No.> Dur. St(Len): data...");
		PutText(hdc, "---");

		while(e)
		{
			TCHAR ts[1024];
			DWORD i;
			DWORD max;

			wsprintf(ts, "<%08d> %08dms %02X(%3d): ", count++, e->time, e->status, e->size);
			max = e->size;
			if(256 < max)
				max = 256;
			for(i = 0; i < max; i++)
			{
				TCHAR hex[4];
				wsprintf(hex, "%02X ", e->data[i]);
				lstrcat(ts, hex);
			}
			PutText(hdc, ts);
			e = e->next;
		}
	}

	PutText(hdc, "READY");
#endif

	{
		int i;
		HPEN hpold = SelectObject(hdc, CreatePen(PS_SOLID, 1, RGB(192, 192, 192)));
		COLORREF oldcolor = SetTextColor(hdc, RGB(192, 192, 192));
		EVENT* e;

		// draw vertical grid
		for(i = -(scrx % 100); i < width; i += 100)
		{
			MoveToEx(hdc, i, 0, NULL);
			LineTo(hdc, i, height);
		}

		// draw horizontal grid
		for(i = 0; i < 128; i++)
		{
			MoveToEx(hdc, 0, (127 - i) * RollHeight - scry, NULL);
			LineTo(hdc, width, (127 - i) * RollHeight - scry);
		}

		for(e = smaf->events; e; e = e->next)
		{
			DWORD gtime;

			if((e->status & 0xF0) != 0x80 && (e->status & 0xF0) != 0x90)	// Not NoteON
				continue;

			if(scrx + width < (signed)e->time)
				break;

			if((e->status & 0xF0) == 0x80)	// NonVel
				gtime = GetVVal(e->data + 1) * smaf->gbase;
			else
				gtime = GetVVal(e->data + 2) * smaf->gbase;

			FillRectangle(hdc,	e->time - scrx,
								(127 - e->data[0]) * RollHeight - scry,
								e->time + gtime - scrx,
								((127 - e->data[0]) + 1) * RollHeight - scry,
								RGB(128, 64, 128));
			FillRectangle(hdc,	e->time - scrx + 1,
								(127 - e->data[0]) * RollHeight - scry + 1,
								e->time + gtime - scrx - 1,
								((127 - e->data[0]) + 1) * RollHeight - scry - 1,
								RGB(255, 128, 255));
		}

		// draw vertical grid
		for(i = -(scrx % 100); i < width; i += 100)
		{
			MoveToEx(hdc, i + 2, 0, NULL);
			PutText(hdc, "%d ms", i + scrx);
		}

		// draw horizontal grid
		for(i = 0; i < 128; i+=12)
		{
			MoveToEx(hdc, 0, (127 - i) * RollHeight - scry, NULL);
			PutText(hdc, "Octave %d", i / 12);
		}

		SetTextColor(hdc, oldcolor);
		DeleteObject(SelectObject(hdc, hpold));
	}

	{
		HPEN hpold = SelectObject(hdc, CreatePen(PS_SOLID, 1, RGB(255, 0, 0)));

		MoveToEx(hdc, playingpos - scrx, 0, NULL);
		LineTo(hdc, playingpos - scrx, height);

		DeleteObject(SelectObject(hdc, hpold));
	}

	DeleteObject(SelectObject(hdc, hfold));

	return;
}

void FreeSmaf(SMAF* smaf)
{
	if(!smaf)
	{
		MessageBox(NULL, "smaf == NULL", "BUG", MB_ICONERROR | MB_OK);
		return;
	}

	if(smaf->data)
		hfree(smaf->data);

	ClearEvents(smaf);

	hfree(smaf);

	return;
}

SMAF* LoadSmaf(LPCTSTR fname)
{
	SMAF* smaf = NULL;
	HANDLE hf = NULL;
	DWORD read;

	if(!(smaf = halloc(sizeof(SMAF))))
		goto Error;

	smaf->data = NULL;
	smaf->events = NULL;

	if((hf = CreateFile(fname, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE)
	{
		TCHAR ts[MAX_PATH + 80];

		wsprintf(ts, "Can't open %s", fname);
		MessageBox(NULL, ts, "Error", MB_ICONERROR | MB_OK);

		goto Error;
	}

	smaf->size = GetFileSize(hf, NULL);

	if(!(smaf->data = halloc(smaf->size)))
	{
		MessageBox(NULL, "Can't alloc memory", "Error", MB_ICONERROR | MB_OK);
		goto Error;
	}
	if(!ReadFile(hf, smaf->data, smaf->size, &read, NULL))
	{
		read = 0;
	}
	if(read < smaf->size)
	{
		MessageBox(NULL, "Couldn't read file.", "Error", MB_ICONERROR | MB_OK);
		goto Error;
	}

	CloseHandle(hf);

	{
		CHUNK chk;
		if(!findchunk4(smaf->data, smaf->size, "MMMD", &chk))
		{
			MessageBox(NULL, "This is not SMAF", "Error", MB_ICONERROR | MB_OK);
			goto Error;
		}

		chk.size -= 2;	// MMMD's CRC

		if(findchunk3(chk.data, chk.size, "MTR", &chk))
		{
			CHUNK dummy;

			switch(chk.data[2])
			{
			case 0x00: smaf->dbase = 1; break;
			case 0x01: smaf->dbase = 2; break;
			case 0x02: smaf->dbase = 4; break;
			case 0x03: smaf->dbase = 5; break;
			case 0x10: smaf->dbase = 10; break;
			case 0x11: smaf->dbase = 20; break;
			case 0x12: smaf->dbase = 40; break;
			case 0x13: smaf->dbase = 50; break;
			default: MessageBox(NULL, "Unknown duration timebase", "Error", MB_ICONERROR | MB_OK); goto Error;
			}

			switch(chk.data[3])
			{
			case 0x00: smaf->gbase = 1; break;
			case 0x01: smaf->gbase = 2; break;
			case 0x02: smaf->gbase = 4; break;
			case 0x03: smaf->gbase = 5; break;
			case 0x10: smaf->gbase = 10; break;
			case 0x11: smaf->gbase = 20; break;
			case 0x12: smaf->gbase = 40; break;
			case 0x13: smaf->gbase = 50; break;
			default: MessageBox(NULL, "Unknown gatetime timebase", "Error", MB_ICONERROR | MB_OK); goto Error;
			}

			if(chk.data[0] == 0x00)	// HPS
			{
				chk.data += 4 + 2;	// skip ChStatus

				if(findchunk4(chk.data, chk.size, "Mtsu", &dummy))
					ConvertEvents2(smaf, dummy.data, dummy.size, TRUE);

				if(findchunk4(chk.data, chk.size, "Mtsq", &dummy))
					ConvertEvents2(smaf, dummy.data, dummy.size, FALSE);
			}

			if(chk.data[0] == 0x01 || chk.data[0] == 0x02)	// MSF
			{
				chk.data += 4 + 16;
				if(findchunk4(chk.data, chk.size, "Mtsu", &dummy))
					ConvertEvents(smaf, dummy.data, dummy.size, TRUE);

				if(findchunk4(chk.data, chk.size, "Mtsq", &dummy))
				{
					if(chk.data[-20] == 0x01)
					{
						BYTE* data;

						data = halloc(SwapDword(dummy.data));
						huffmanDecode(data, dummy.data + 4, SwapDword(dummy.data), dummy.size);
						ConvertEvents(smaf, data, SwapDword(dummy.data), FALSE);
						hfree(data);
					}
					if(chk.data[-20] == 0x02)
						ConvertEvents(smaf, dummy.data, dummy.size, FALSE);
				}
			}
		}
	}

	return smaf;
Error:
	if(smaf)
	{
		FreeSmaf(smaf);
	}
	if(hf)
	{
		CloseHandle(hf);
	}

	return NULL;
}

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static BOOL sounding = FALSE;
	static SMAF* smaf = NULL;
	static int refrate = 10;

	static int inputtingnum;
	static char inputtingtype;
	static BOOL isinputting = FALSE;
	static BOOL isinputfirst;

	switch(msg)
	{
	case WM_CREATE:
		EmuInit();

		break;
	case WM_MOUSEWHEEL:
		if((short)HIWORD(wParam) > 0)
			PostMessage(hWnd, WM_VSCROLL, SB_PAGEUP, 0);
		else
			PostMessage(hWnd, WM_VSCROLL, SB_PAGEDOWN, 0);
		break;
	case WM_KEYDOWN:
		if((int)wParam == VK_SHIFT)
			if(!isinputting)
			{
				isinputting = TRUE;
				isinputfirst = TRUE;
				inputtingnum = 0;
				inputtingtype = 0;
				InvalidateRect(hWnd, NULL, FALSE);
			}

		if(isinputting)
		{
			if('0' <= (int)wParam && (int)wParam <= '9')
			{
				if(isinputfirst)
				{
					isinputfirst = FALSE;
					inputtingnum = 0;
				}
				inputtingnum = inputtingnum * 10 + (int)wParam - '0';
				InvalidateRect(hWnd, NULL, FALSE);
			}
			if((int)wParam == VK_OEM_MINUS)
			{
				inputtingnum = -inputtingnum;
				InvalidateRect(hWnd, NULL, FALSE);
			}
			if((int)wParam == VK_BACK || (int)wParam == VK_DELETE)
			{
				inputtingnum = inputtingnum / 10;
				InvalidateRect(hWnd, NULL, FALSE);
			}
			if('A' <= (int)wParam && (int)wParam <= 'Z')
			{
				inputtingtype = (char)wParam;
				isinputfirst = TRUE;
				switch(inputtingtype)
				{
				case 'R':
					inputtingnum = refrate;
					break;
				case 'D':
					inputtingnum = DrawFunc;
					break;
				case 'H':
					inputtingnum = RollHeight;
					break;
				case 'T':
					inputtingnum = EmuPlayTempo;
					break;
				case 'K':
					inputtingnum = EmuPlayKeypitch;
					break;
				case 'W':
					inputtingnum = RollWidth;
					break;
				}
				InvalidateRect(hWnd, NULL, FALSE);
			}
		}
		break;
	case WM_KEYUP:
		if((int)wParam == VK_SHIFT)
			if(isinputting)
			{
				isinputting = FALSE;
				switch(inputtingtype)
				{
				case 'R':
					if(inputtingnum > 0)
						refrate = inputtingnum;
					if(sounding)
					{
						KillTimer(hWnd, 0);
						SetTimer(hWnd, 0, refrate, NULL);
					}
					break;
				case 'D':
					if(0 <= inputtingnum && inputtingnum <= 2)
						DrawFunc = inputtingnum;
					break;
				case 'H':
					if(inputtingnum > 0)
						RollHeight = inputtingnum;
					break;
				case 'T':
					if(70 <= inputtingnum && inputtingnum <= 130)
					{
						// e|(%) between 70 to 130.
						EmuPlayTempo = inputtingnum;
						if(MaSound_Control(1, 1, 1, &EmuPlayTempo, 0))
						{
							MessageBox(NULL, "Control tempo failed!", "Error", MB_ICONERROR | MB_OK);
						}
					}
					break;
				case 'K':
					if(-12 <= inputtingnum && inputtingnum <= 12)
					{
						// L[sb` between -12 to 12
						EmuPlayKeypitch = inputtingnum;
						if(MaSound_Control(1, 1, 2, &EmuPlayKeypitch, 0))
						{
							MessageBox(NULL, "Control keypitch failed!", "Error", MB_ICONERROR | MB_OK);
						}
					}
					break;
				case 'W':
					if(inputtingnum > 0)
						RollWidth = inputtingnum;
					break;
				}
				InvalidateRect(hWnd, NULL, FALSE);
			}
		break;
	case WM_HSCROLL:
	case WM_VSCROLL:
		{
			SCROLLINFO scr;

			scr.cbSize = sizeof(scr);
			scr.fMask = SIF_ALL;
			if(msg == WM_HSCROLL)
				GetScrollInfo(hWnd, SB_HORZ, &scr);
			if(msg == WM_VSCROLL)
				GetScrollInfo(hWnd, SB_VERT, &scr);

			switch(LOWORD(wParam))
			{
			//case SB_TOP:
			case SB_LEFT:
				scr.nPos = scr.nMin;
				break;
			//case SB_BOTTOM:
			case SB_RIGHT:
				scr.nPos = scr.nMax;
				break;
			//case SB_LINEUP:
			case SB_LINELEFT:
				if(scr.nMin < scr.nPos)
					scr.nPos--;
				break;
			//case SB_LINEDOWN:
			case SB_LINERIGHT:
				if(scr.nPos < scr.nMax - 1)
					scr.nPos++;
				break;
			//case SB_PAGEUP:
			case SB_PAGELEFT:
				scr.nPos -= scr.nPage;
				break;
			//case SB_PAGEDOWN:
			case SB_PAGERIGHT:
				scr.nPos += scr.nPage;
				break;
			case SB_THUMBPOSITION:
			case SB_THUMBTRACK:
				scr.nPos = HIWORD(wParam);
				break;
			}

			scr.fMask = SIF_POS;
			if(msg == WM_HSCROLL)
				SetScrollInfo(hWnd, SB_HORZ, &scr, TRUE);
			if(msg == WM_VSCROLL)
				SetScrollInfo(hWnd, SB_VERT, &scr, TRUE);

			InvalidateRect(hWnd, NULL, FALSE);
		}

		return 0;
	case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hdc;
			RECT rc;

			HDC hdcbg;
			HBITMAP oldbmp;
			BITMAPINFO bi = {0};

			hdc = BeginPaint(hWnd, &ps);
			GetClientRect(hWnd, &rc);

			switch(DrawFunc)
			{
			case 0:
				break;
			case 1:
				hdcbg = hdc;
				hdc = CreateCompatibleDC(hdcbg);

				bi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
				bi.bmiHeader.biPlanes = 1;
				bi.bmiHeader.biWidth = rc.right;
				bi.bmiHeader.biHeight = rc.bottom;
				bi.bmiHeader.biBitCount = 24;
				oldbmp = SelectObject(hdc, CreateDIBSection(hdc, &bi, DIB_RGB_COLORS, NULL, NULL, 0));

				break;
			case 2:
				hdcbg = hdc;
				hdc = CreateCompatibleDC(hdcbg);

				oldbmp = SelectObject(hdc, CreateCompatibleBitmap(hdcbg, rc.right, rc.bottom));

				break;
			}

			draw(hWnd, hdc, rc.right, rc.bottom, smaf, MaSound_Control(1, 1, 4, 0, 0));
			if(isinputting)
			{
				MoveToEx(hdc, 0, 0, NULL);
				SaveDC(hdc);
				SetBkMode(hdc, OPAQUE);
				SetBkColor(hdc, RGB(255, 255, 255));
				switch(inputtingtype)
				{
				case 0:
					break;
				case 'R':
					PutText(hdc, "Refresh Rate: %d", inputtingnum);
					break;
				case 'D':
					PutText(hdc, "Draw Function: %d", inputtingnum);
					break;
				case 'H':
					PutText(hdc, "PianoRoll's Height: %d", inputtingnum);
					break;
				case 'T':
					PutText(hdc, "Tempo: %d", inputtingnum);
					break;
				case 'K':
					PutText(hdc, "KeyPitch: %d", inputtingnum);
					break;
				case 'W':
					PutText(hdc, "PianoRoll's Width divider: %d", inputtingnum);
					break;
				default:
					PutText(hdc, "INVALID TYPE");
					break;
				}
				RestoreDC(hdc, -1);
			}

			switch(DrawFunc)
			{
			case 0:
				break;
			case 1:
			case 2:
				BitBlt(hdcbg, 0, 0, rc.right, rc.bottom, hdc, 0, 0, SRCCOPY);

				DeleteObject(SelectObject(hdc, oldbmp));
				DeleteDC(hdc);

				break;
			}

			EndPaint(hWnd, &ps);
		}
		break;
	case WM_COMMAND:
		switch(HIWORD(wParam))
		{
		case 0:	// Command
		case 1:	// Accelerator
			switch(LOWORD(wParam))
			{
			case ID_OPENSMAF:
				{
					OPENFILENAME ofn = {0};
					TCHAR fname[MAX_PATH];

					ofn.lStructSize = sizeof(ofn);
					ofn.Flags = OFN_FILEMUSTEXIST;
					ofn.hInstance = GetModuleHandle(NULL);
					ofn.hwndOwner = hWnd;
					ofn.lpstrTitle = "Open SMAF";
					fname[0] = '\0';
					ofn.lpstrFile = fname;
					ofn.nMaxFile = sizeof(fname);
					ofn.lpstrFilter = "SMAF file(*.mmf)\0*.mmf\0";

					if(GetOpenFileName(&ofn))
					{
						if(smaf)
							SendMessage(hWnd, WM_COMMAND, ID_CLOSE, 0);

						smaf = LoadSmaf(fname);
						EmuOpen(smaf);

						SetScrollPos(hWnd, SB_HORZ, 0, TRUE);
						SetScrollPos(hWnd, SB_VERT, 0, TRUE);

						InvalidateRect(hWnd, NULL, FALSE);
					}
				}
				break;
			case ID_CLOSE:
				if(smaf)
				{
					if(sounding)
						SendMessage(hWnd, WM_COMMAND, ID_STOP, 0);
					EmuClose();
					FreeSmaf(smaf);
					smaf = NULL;

					InvalidateRect(hWnd, NULL, FALSE);
				}
				break;
			case ID_EXIT:
				PostMessage(hWnd, WM_CLOSE, 0, 0);
				break;
			case ID_HELPINDEX:
				MessageBox(hWnd, "There are no help.", "sorry", MB_ICONERROR | MB_OK);
				break;
			case ID_ABOUT:
				DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_ABOUT), hWnd, MessageDlgWndProc, 0);
				break;
			case ID_PLAY:
				if(smaf && !sounding)
				{
					EmuPlay(smaf);
					sounding = TRUE;
					SetTimer(hWnd, 0, refrate, NULL);
				}
				break;
			case ID_STOP:
				if(smaf && sounding)
				{
					EmuStop();
					sounding = FALSE;
					KillTimer(hWnd, 0);

					SetWindowText(hWnd, "mmf tool");

					InvalidateRect(hWnd, NULL, FALSE);
				}
				break;
			case ID_REWIND:
				if(smaf)
				{
					if(sounding)
					{
						EmuStop();
						sounding = FALSE;
						KillTimer(hWnd, 0);

						SetWindowText(hWnd, "mmf tool");

					}
					if(MaSound_Seek(1, 1, 0, 0, 0))
					{
						MessageBox(hWnd, "Seek failed", "Error", MB_ICONERROR | MB_OK);
					}
					InvalidateRect(hWnd, NULL, FALSE);
				}
				break;
			}
			break;
		}
		break;
	case WM_LBUTTONDOWN:
		if(smaf)
		{
			int x;

			x = GetScrollPos(hWnd, SB_HORZ) + LOWORD(lParam);

			if(sounding)
				EmuStop();
			if(MaSound_Seek(1, 1, x, 0, 0))
			{
				MessageBox(hWnd, "Seek failed", "Error", MB_ICONERROR | MB_OK);
			}
			if(sounding)
				EmuPlay(smaf);

			InvalidateRect(hWnd, NULL, FALSE);
		}
		break;
	case WM_TIMER:
		if(sounding)
		{
			EmuStatus(hWnd);
			if(GetAsyncKeyState(VK_SHIFT) & 0x8000)
			{
				SetScrollPos(hWnd, SB_HORZ, MaSound_Control(1, 1, 4, 0, 0) - 100, TRUE);
			}
			InvalidateRect(hWnd, NULL, FALSE);
		}
		break;
	case WM_SIZE:
		{
			SCROLLINFO si;

			si.cbSize = sizeof(si);
			si.fMask = SIF_ALL | SIF_DISABLENOSCROLL;
			si.nMin = 0;
			si.nMax = 65535;
			si.nPage = 10;
			si.nPos = 0;
			SetScrollInfo(hWnd, SB_HORZ, &si, TRUE);

			si.nMin = 0;
			si.nMax = 256 * 8;
			si.nPage = 10;
			si.nPos = 0;
			SetScrollInfo(hWnd, SB_VERT, &si, TRUE);
		}
		break;
	case WM_CLOSE:
		if(smaf)
			SendMessage(hWnd, WM_COMMAND, ID_CLOSE, 0);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);

		EmuTerminate();
		break;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

BOOL initWnd(void)
{
	WNDCLASSEX wc = {0};
	
	wc.cbSize = sizeof(wc);
	wc.hbrBackground = (HBRUSH)(COLOR_3DFACE + 1);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hInstance = GetModuleHandle(NULL);
	wc.hIcon = LoadIcon(wc.hInstance, MAKEINTRESOURCE(IDI_MAIN));
	wc.lpfnWndProc = MainWndProc;
	wc.lpszClassName = "MMFToolWC";
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpszMenuName = MAKEINTRESOURCE(IDR_MAIN);

	if(!RegisterClassEx(&wc))
		return FALSE;

	// I don't like WS_OVERLAPPED.
	if(!CreateWindowEx(WS_EX_CLIENTEDGE, wc.lpszClassName, "mmf tool", WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_SIZEBOX | WS_MAXIMIZEBOX | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, wc.hInstance, NULL))
		return FALSE;

	return TRUE;
}

void WinMainCRTStartup(void)
{
	if(!initWnd())
		ExitProcess(0);

	{
		MSG msg;
		HACCEL at;

		at = LoadAccelerators(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_MAIN));

		while(GetMessage(&msg, NULL, 0, 0))
		{
			if(!TranslateAccelerator(msg.hwnd, at, &msg))
				TranslateMessage(&msg);
			DispatchMessage(&msg);
		}

		ExitProcess(msg.wParam);
	}
}
